        .intel_syntax

#ifdef SSE

/////////////////////////////////////////////////////////////////////
//
// subsample_line_yuy2_2
//
        .globl _subsample_line_yuy2_2
        .align 16
_subsample_line_yuy2_2:
        prefetchnta [eax]
        lea     ecx, [ecx+eax]
        movd mm0, ebx
        mov  ebx, 0x00FF00FF
        movd mm7, ebx
        movd ebx, mm0
        PUNPCKLDQ mm7,mm7
        pxor mm0, mm0
        .align 16
Lyuy2_loop:
        
        movq  mm2, [eax]
        pand  mm2, mm7
        movq  mm1, [eax + 8]
        pand  mm1, mm7
        
        prefetchnta [eax + 16]
        
        packuswb mm2,mm1
        
        movq  mm3, mm2
        pand  mm2, mm7
        psrlq mm3, 8
        pand  mm3, mm7
        movq  mm1, mm3
        psllq mm1, 16
        paddw mm2, mm3
        por   mm1, mm0
        paddw mm2, mm1

        movq [edx], mm2
        
        movq  mm0, mm3
        psrlq mm0, 48 

        add     eax, 16
        add     edx, 8
        cmp     eax, ecx
        jb      Lyuy2_loop

        ret

/////////////////////////////////////////////////////////////////////
//
// subsample_line_yv12_2
//
        .globl _subsample_line_yv12_2
        .align 16
_subsample_line_yv12_2:
        prefetchnta [eax]
        lea     ecx, [ecx+eax]
        movd mm0, ebx
        mov  ebx, 0x00FF00FF
        movd mm7, ebx
        movd ebx, mm0
        PUNPCKLDQ mm7,mm7
        pxor mm0, mm0
        .align 16
Lyv12_loop:
        movq  mm2, [eax]

        prefetchnta [eax + 8]

        movq  mm3, mm2
        pand  mm2, mm7
        psrlq mm3, 8
        pand  mm3, mm7
        movq  mm1, mm3
        psllq mm1, 16
        paddw mm2, mm3
        por   mm1, mm0
        paddw mm2, mm1

        movq [edx], mm2

        movq  mm0, mm3
        psrlq mm0, 48 

        add     eax, 8
        add     edx, 8
        cmp     eax, ecx
        jb      Lyv12_loop

        ret

/////////////////////////////////////////////////////////////////////
//
// compare_fields
//
        .globl _compare_fields
	.align 16
_compare_fields:
	push	ebp
	push	edi
	push	esi
	push	ebx
	sub	esp, 60

	mov	ebp, [esp+80] // ebp = parms [entire function]
	mov	eax, [ebp+20] // 
	mov [esp+ 4], eax     // a
	mov     edi, [ebp+16] // edi = pitch
	add     edi, edi
	lea     ebx, [edi + eax]
	mov [esp+ 8], ebx     // b
	lea     ecx, [edi + ebx]
	mov [esp+12], ecx     // c
	lea     edx, [edi + ecx]
	mov [esp+16], edx     // d
	lea     esi, [edi + edx]
	mov [esp+20], esi     // e
                              
	mov     eax, [esp+84]
                              // d already in edx register
	mov	ecx, [ebp+4]
	call	[[ebp]]

	mov     eax, [esp+92]
	mov     edx, esi
	mov	ecx, [ebp+4]
	call	[[ebp]]

	xorps   xmm0, xmm0 // xmm0 = accum [entire function]
	
        mov     DWORD PTR [esp+24], 0 // line

Lcf_outer:
        mov    eax, [esp+4] // swap a d
        mov    ebx, [esp+16]
        mov    [esp+ 4], ebx
        mov    [esp+16], eax
        
        mov    eax, [esp+8] // swap b e
        mov    ebx, [esp+20]
        mov    [esp+ 8], ebx
        mov    [esp+20], eax

	mov	esi, [esp+24]
	and	esi, 1

	mov	ebx, [esp+84+esi*8]
	add	ebx, [esp+88+esi*8]
	mov	eax, ebx
	mov	edx, [esp+12]
	mov     ecx, [ebp+4]
	call	[[ebp]]

	add	ebx, [esp+88+esi*8]
	mov     eax, ebx
	mov	edx, [esp+20]
	mov	ecx, [ebp+4]
	call	[[ebp]]

	mov	[esp+84+esi*8], ebx
	xor	esi, 1

	mov	eax, [esp+84+esi*8]
	add	eax, [esp+88+esi*8]
	mov	[esp+84+esi*8], eax
	mov     edx, [esp+16]
	mov	ecx, [ebp+4]
	call	[[ebp]]

	// loop prep
        mov  eax, 0x00030003
        movd mm6, eax
        PUNPCKLDQ mm6,mm6

        mov     edi, [ebp + 12]
        add     edi, edi
        mov     eax, [esp+ 4] // eax = a [for inner loop]
        add     eax, edi
        mov     ebx, [esp+ 8] // eax = b [for inner loop]
        add     ebx, edi
        mov     ecx, [esp+12] // eax = c [for inner loop]
        add     ecx, edi
        mov     edx, [esp+16] // eax = d [for inner loop]
        add     edx, edi
        mov     esi, [esp+20] // eax = e [for inner loop]
        add     esi, edi

        neg     edi       // edi = x [for inner loop]

        pxor mm0,mm0        
        .align 16
Lcf_inner:
        movq    mm1, [edi + ebx] // b  = B
        paddsw  mm1, [edi + edx] // b += D
        pmullw  mm1, mm6         // b *= 3
        movq    mm2, [edi + ecx] // c  = C
        psllw   mm2, 2           // c *= 4
        paddsw  mm2, [edi + eax] // c += A
        paddsw  mm2, [edi + esi] // c += E
        psubsw  mm2, mm1         // c -= b
        pmaddwd mm2, mm2         // c *= c
        cvtpi2ps xmm1, mm2       
        addps   xmm0, xmm1       // r += c

	add	edi, 8
	jl	Lcf_inner
	
        // outer loop inc and test
        mov     eax, [ebp + 8]
        mov     esi, [esp + 24]
        inc     esi
        mov     [esp + 24], esi
	cmp	esi, eax
	jl	Lcf_outer

        movaps  xmm1, xmm0
        shufps  xmm1, xmm1, 0x01
        addss   xmm0, xmm1
	mulss	xmm0, [ebp+24]
	movss	[esp+0], xmm0
        emms
	fld	[esp+0]
	add	esp, 60
	pop	ebx
	pop	esi
	pop	edi
	pop	ebp
	ret

#endif // DEF SSE

